#include "Xbp.ch"
#include "Gra.ch"

PROCEDURE Appsys
RETURN

PROCEDURE Main(cFile)
LOCAL oBMP
LOCAL aSize
LOCAL oBild

   IF EMPTY(cFile)
      Msgbox("need BMP / JPG / PNG file","Error no file")
      QUIT
   ENDIF

   FERASE("B1366x768.JPG")
   FERASE("B1366x699.JPG")
   FERASE("B640x480.JPG" )

   oBMP  := XbpBitmap():new():create()
   oBMP:loadFile(cFile)

   aSize := {1366,768}
   oBild := BMP2BMP2( oBMP, aSize )
   oBild:saveFile( "B1366x768.JPG",XBPBMP_FORMAT_JPG)

   aSize := {1366,699}
   oBild := BMP2BMP2( oBMP, aSize )
   oBild:saveFile( "B1366x699.JPG",XBPBMP_FORMAT_JPG)

   aSize := {640,480}
   oBild := BMP2BMP2( oBMP, aSize )
   oBild:saveFile( "B640x480.JPG" ,XBPBMP_FORMAT_JPG)

   Msgbox("ready")
   QUIT

RETURN

STATIC FUNCTION BMP2BMP2( oBMP, aIcoSize )
LOCAL oTiny
LOCAL oPS
LOCAL oRet
LOCAL nBits
LOCAL nPlanes
LOCAL nBGClr
LOCAL aRGB

  IF aIcoSize[ 2 ] > 0
      nBits    := oBMP:bits
      nPlanes  := oBMP:planes
      nBGClr   := oBMP:getDefaultBgColor()

      oPS := XBPPRESSPACE() :new()
      oTiny := XBPBITMAP():New():Create()

      IF nBGClr = 16777216
         aRGB := GraGetRGBIntensity(nBGClr)
         oTiny:transparentClr := GraMakeRGBColor(aRGB)
      ELSE
         oTiny:transparentClr := oBMP:getDefaultBgColor()
      ENDIF

      IF nBits > 1 .AND. nPlanes > 1
         oTiny:Make( aIcoSize[ 1 ], aIcoSize[ 2 ], nPlanes, nBits )
      ELSE
         oTiny:Make( aIcoSize[ 1 ], aIcoSize[ 2 ] )
      ENDIF
      oTiny:presSpace( oPS )

      IF aIcoSize[ 2 ] > oBMP:ySize
         oBMP:Draw( oPS, { 0, 0, aIcoSize[1], aIcoSize[2] },,, GRA_BLT_BBO_IGNORE )
      ELSE
         oBMP:Draw( oPS, { 0, 0, aIcoSize[1], aIcoSize[2] },,, 4  )
      ENDIF
      oRet := oTiny
   ELSE
      oRet := oBMP
   ENDIF

RETURN oRet

*
* eof
*